<?php
// Client for cache daemon.
error_reporting(E_ALL);
ini_set("track_errors", "On");
set_time_limit(0);

$_s = microtime(TRUE);

require_once("/etc/rocketgit/config.php");

$INC = dirname(__FILE__) . "/../inc";
require_once($INC . "/init.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/sql.inc.php");
require_once($INC . "/struct.inc.php");
require_once($INC . "/cache.inc.php");
require_once($INC . "/repo.inc.php");
require_once($INC . "/prof.inc.php");
require_once($INC . "/mr.inc.php");
require_once($INC . "/keys.inc.php");
require_once($INC . "/user.inc.php");
require_once($INC . "/bug.inc.php");
require_once($INC . "/fixes.inc.php");

rg_prof_start("MAIN");

rg_log_set_file($rg_log_dir . "/cachec.log");
rg_log_set_sid("000000"); // to spread the logs

$master = @socket_create(AF_UNIX, SOCK_STREAM, 0);
if ($master === FALSE) {
	rg_internal_error("Cannot create events socket!");
	exit(1);
}

$ret = @socket_connect($master, $rg_cache_socket);
if ($ret === FALSE) {
	echo "Cannot connect: " . socket_strerror(socket_last_error()) . "!\n";
	exit(1);
}

$in = fopen("php://stdin", "r");
if ($in === FALSE) {
	echo "Cannot open stdin!\n";
	exit(1);
}

do {
	echo "Command: ";
	$r = fgets($in, 4096);
	$r = trim($r);
	if (strlen($r) == 0)
		break;

	$r .= "\n";
	$r = socket_send($master, $r, strlen($r), 0);
	if ($r === FALSE)
		break;
	$r = socket_recv($master, $buf, 4096, 0);
	echo $buf;
} while (1);

socket_close($master);

rg_prof_end("MAIN");
rg_prof_log();
?>
